import { mesg } from "@mesg/api/lib/typedef/execution";
import { Stream } from '@mesg/api/lib/util/grpc';
import { IApi } from '@mesg/api/lib/types';
import { hash } from '@mesg/api/lib/types';
import { EventStreamInputs, IEvent } from '@mesg/api/lib/event';
import { ExecutionStreamInputs, IExecution, ExecutionCreateInputs, ExecutionCreateOutputs } from '@mesg/api/lib/execution';
declare type Options = {
    api?: IApi;
};
declare class Application {
    private api;
    constructor(_api?: IApi);
    decodeData(data: mesg.protobuf.IStruct): {
        [key: string]: any;
    };
    encodeData(data: {
        [key: string]: any;
    }): mesg.protobuf.IStruct;
    resolve(sid: string): Promise<hash>;
    listenEvent(request: EventStreamInputs): Stream<IEvent>;
    listenResult(request: ExecutionStreamInputs): Stream<IExecution>;
    executeTask(request: ExecutionCreateInputs): ExecutionCreateOutputs;
    executeTaskAndWaitResult(request: ExecutionCreateInputs): Promise<IExecution>;
}
export default Application;
export { Options, Stream, };
